import { expect } from "chai";
import { GeneratorTool } from "../../../tools/GeneratorTool";
import { GenericDbTable } from "../../../db/model/GenericDbTable";
import { GenericDbField } from "../../../db/model/GenericDbField";
import { GenericDbFKey } from "../../../db/model/GenericDbFKey";
import { EnumDbRule } from "../../../db/model/EnumDbRule";

// import * as myExtension from '../../extension';

suite("GeneratorTool Test Suite", () => {
  console.log("Start GeneratorTool tests.");

  setup(() => {});

  test("extractEnvKey test", () => {
    // Test extracting env key
    expect(GeneratorTool.extractEnvKey("${MYENV}")).to.equal("MYENV");
    expect(GeneratorTool.extractEnvKey("${MY_PASSWORD_VERY_STRONG}")).to.equal("MY_PASSWORD_VERY_STRONG");
    // Test when there is no env key
    expect(GeneratorTool.extractEnvKey("this_isNotAstrongPasSwOrD")).to.be.undefined;
  });

  test("getPercent test", () => {
    // Test case where current equals total
    expect(GeneratorTool.getPercent(100, 100)).to.equal(100);
    // Test case where current is half of total
    expect(GeneratorTool.getPercent(200, 100)).to.equal(50);
    // Test case where current is less than total
    expect(GeneratorTool.getPercent(300, 100)).to.equal(34);
    // Test case where current is greater than total (should be capped at 100%)
    expect(GeneratorTool.getPercent(50, 100)).to.equal(100);
  });

  test("filterTables test", () => {
    // Define some sample tables
    const tables: GenericDbTable[] = [{ tableName: "Table1" }, { tableName: "Table2" }, { tableName: "Table3" }] as GenericDbTable[];

    // Test case where no tables are skipped or exclusively processed
    expect(GeneratorTool.filterTables(tables)).to.deep.equal(tables);

    // Test case where some tables are skipped
    const skipTables = ["Table2"];
    const expectedResult1: GenericDbTable[] = [{ tableName: "Table1" }, { tableName: "Table3" }] as GenericDbTable[];
    expect(GeneratorTool.filterTables(tables, skipTables)).to.deep.equal(expectedResult1);

    // Test case where some tables are exclusively processed
    const onlyTables = ["Table2", "Table3"];
    const expectedResult2: GenericDbTable[] = [{ tableName: "Table2" }, { tableName: "Table3" }] as GenericDbTable[];
    expect(GeneratorTool.filterTables(tables, undefined, onlyTables)).to.deep.equal(expectedResult2);

    // Test case where both skip and only tables are provided
    const expectedResult3: GenericDbTable[] = [{ tableName: "Table3" }] as GenericDbTable[];
    expect(GeneratorTool.filterTables(tables, skipTables, onlyTables)).to.deep.equal(expectedResult3);
  });

  test("upperFirstLetter test", () => {
    expect(GeneratorTool.upperFirstLetter("myclass")).to.equal("Myclass");
    expect(GeneratorTool.upperFirstLetter("Myclass")).to.equal("Myclass");
    expect(GeneratorTool.upperFirstLetter("mYcLASS", true)).to.equal("Myclass");
    expect(GeneratorTool.upperFirstLetter("")).to.equal("");
    expect(GeneratorTool.upperFirstLetter("a")).to.equal("a"); // When string is length of 1 we don't touch it
  });

  test("getPkeyFields test", () => {
    const fields: GenericDbField[] = [
      {
        fieldName: "id",
        value: 1,
        type: undefined,
        isNullable: false,
        isPKey: true,
        isFKey: false,
        isAutogenerated: true
      },
      {
        fieldName: "name",
        value: "example",
        type: undefined,
        isNullable: true,
        isPKey: false,
        isFKey: false,
        isAutogenerated: false
      },
      {
        fieldName: "refId",
        value: 2,
        type: undefined,
        isNullable: false,
        isPKey: true,
        isFKey: true,
        isAutogenerated: false
      }
    ];
  
    const expectedResult = [
      {
        fieldName: "id",
        value: 1,
        type: undefined,
        isNullable: false,
        isPKey: true,
        isFKey: false,
        isAutogenerated: true
      },
      {
        fieldName: "refId",
        value: 2,
        type: undefined,
        isNullable: false,
        isPKey: true,
        isFKey: true,
        isAutogenerated: false
      }
    ];
  
    expect(GeneratorTool.getPkeyFields(fields)).to.deep.equal(expectedResult);
  });
  

  test("getFkeyFields test", () => {
    const fields: GenericDbField[] = [
      {
        fieldName: "id",
        value: 1,
        type: undefined,
        isNullable: false,
        isPKey: true,
        isFKey: false,
        isAutogenerated: true
      },
      {
        fieldName: "name",
        value: "example",
        type: undefined,
        isNullable: true,
        isPKey: false,
        isFKey: false,
        isAutogenerated: false
      },
      {
        fieldName: "refId",
        value: 2,
        type: undefined,
        isNullable: false,
        isPKey: true,
        isFKey: true,
        isAutogenerated: false
      }
    ];
  
    const expectedResult = [
      {
        fieldName: "refId",
        value: 2,
        type: undefined,
        isNullable: false,
        isPKey: true,
        isFKey: true,
        isAutogenerated: false
      }
    ];
  
    expect(GeneratorTool.getFkeyFields(fields)).to.deep.equal(expectedResult);
  });
  

  test("txtToSingularize test", () => {
    expect(GeneratorTool.txtToSingularize("tables")).to.equal("table");
    expect(GeneratorTool.txtToSingularize("boxes")).to.equal("box");
    expect(GeneratorTool.txtToSingularize("children")).to.equal("child");
    expect(GeneratorTool.txtToSingularize("")).to.equal("");
    expect(GeneratorTool.txtToSingularize(undefined)).to.be.undefined;
  });

  test("txtToPluralize test", () => {
    expect(GeneratorTool.txtToPluralize("table")).to.equal("tables");
    expect(GeneratorTool.txtToPluralize("box")).to.equal("boxes");
    expect(GeneratorTool.txtToPluralize("child")).to.equal("children");
    expect(GeneratorTool.txtToPluralize("")).to.equal("");
    expect(GeneratorTool.txtToPluralize(undefined)).to.be.undefined;
  });

  test("getFKeyFromField test", () => {
    const fields: GenericDbField[] = [
      {
        fieldName: "id",
        value: 1,
        type: undefined,
        isNullable: false,
        isPKey: true,
        isFKey: false,
        isAutogenerated: true
      },
      {
        fieldName: "name",
        value: "example",
        type: undefined,
        isNullable: true,
        isPKey: false,
        isFKey: false,
        isAutogenerated: false
      },
      {
        fieldName: "refId",
        value: 2,
        type: undefined,
        isNullable: false,
        isPKey: true,
        isFKey: true,
        isAutogenerated: false
      }
    ];
  
    const fKeys: GenericDbFKey[] = [
      {
        tableName: "MainTable",
        columnName: "refId",
        constraintName: "fk_main_ref",
        referencedTable: "ReferencedTable",
        referencedColumn: "id",
        constraintPosition: 1,
        updateRule: EnumDbRule.CASCADE,
        deleteRule: EnumDbRule.RESTRICT
      },
      {
        tableName: "MainTable",
        columnName: "otherId",
        constraintName: "fk_main_other",
        referencedTable: "OtherTable",
        referencedColumn: "id",
        constraintPosition: 1,
        updateRule: EnumDbRule.CASCADE,
        deleteRule: EnumDbRule.RESTRICT
      }
    ];
  
    const expectedResult: GenericDbFKey = {
      tableName: "MainTable",
      columnName: "refId",
      constraintName: "fk_main_ref",
      referencedTable: "ReferencedTable",
      referencedColumn: "id",
      constraintPosition: 1,
      updateRule: EnumDbRule.CASCADE,
      deleteRule: EnumDbRule.RESTRICT
    };
  
    expect(GeneratorTool.getFKeyFromField(fields[2], fKeys)).to.deep.equal(expectedResult);
  
    const noMatchField: GenericDbField = {
      fieldName: "nonExistentField",
      value: undefined,
      type: undefined,
      isNullable: undefined,
      isPKey: undefined,
      isFKey: undefined,
      isAutogenerated: undefined
    };
    expect(GeneratorTool.getFKeyFromField(noMatchField, fKeys)).to.be.undefined;
  
    const ambiguousField: GenericDbField = {
      fieldName: "otherId_",
      value: undefined,
      type: undefined,
      isNullable: undefined,
      isPKey: undefined,
      isFKey: true,
      isAutogenerated: undefined
    };
    expect(GeneratorTool.getFKeyFromField(ambiguousField, fKeys)).to.be.undefined;
  });
    
  test("processClassNameFromTable test", () => {
    // Test with various table names
    expect(GeneratorTool.processClassNameFromTable("users")).to.equal("User");
    expect(GeneratorTool.processClassNameFromTable("UserProfiles")).to.equal("Userprofile");
    expect(GeneratorTool.processClassNameFromTable("")).to.equal("");
    expect(GeneratorTool.processClassNameFromTable("A")).to.equal("A");
    expect(GeneratorTool.processClassNameFromTable("b")).to.equal("b");
  });

  test("processClassNameFromTableCamel test", () => {
    // Test with various table names
    expect(GeneratorTool.processClassNameFromTableCamel("users")).to.equal("User");
    expect(GeneratorTool.processClassNameFromTableCamel("UserProfiles")).to.equal("Userprofile");
    expect(GeneratorTool.processClassNameFromTableCamel("")).to.equal("");
    expect(GeneratorTool.processClassNameFromTableCamel("A")).to.equal("A");
    expect(GeneratorTool.processClassNameFromTableCamel("b")).to.equal("b");
  });

  test("stringToCamel test", () => {
    // Test camel case conversion
    expect(GeneratorTool.stringToCamel({ rText: "my_variable_name" })).to.equal("MyVariableName");
    expect(GeneratorTool.stringToCamel({ rText: "another_example_here", rFirstLower: true })).to.equal("anotherExampleHere");
    expect(GeneratorTool.stringToCamel({ rText: "one-More-Test", rSep: "-" })).to.equal("OneMoreTest");
    expect(GeneratorTool.stringToCamel({ rText: "oneMoreTest", rSep: "-" })).to.equal("OneMoreTest");
    expect(GeneratorTool.stringToCamel({ rText: "justoneword" })).to.equal("Justoneword");
    expect(GeneratorTool.stringToCamel({ rText: "a" })).to.equal("a");
  });

  test("camelToString test", () => {
    // Test conversion from camelCase or PascalCase to separated format
    expect(GeneratorTool.camelToString({ rText: "MyVariableName" })).to.equal("my_variable_name");
    expect(GeneratorTool.camelToString({ rText: "anotherExampleHere", rSep: "-", rLowerCase: true })).to.equal("another-example-here");
    expect(GeneratorTool.camelToString({ rText: "OneMoreTest", rSep: "-", rLowerCase: false })).to.equal("One-More-Test");
    expect(GeneratorTool.camelToString({ rText: "justoneword" })).to.equal("justoneword");
    expect(GeneratorTool.camelToString({ rText: "A" })).to.equal("a");
    expect(GeneratorTool.camelToString({ rText: "AnotherExampleHere", rSep: ".", rLowerCase: true })).to.equal("another.example.here");
  });  

});
